'use strict';

var parse = require('parse/node');
var baseManager = require('./base-manager');
var ParseServer = require('parse-server').ParseServer;
var ParseDashboard = require('parse-dashboard');
var parseManager = Object.assign({}, baseManager, {
  configureCommon: function configureCommon(app, io) {
    var serverURL = 'http://' + app.config.host + ':' + app.config.port + app.config.PARSE_PATH;
    parse.initialize();
    parse.serverURL = serverURL;

    app.use(app.config.PARSE_PATH, new ParseServer({
      databaseURI: app.config.MONGO_URI ? app.config.MONGO_URI : 'mongodb://' + app.config.MONGO_HOST + ':' + app.config.MONGO_PORT + '/' + app.config.MONGO_DB,
      appId: app.config.PARSE_APPLICATION_ID,
      masterKey: app.config.PARSE_MASTER_KEY,
      serverURL: serverURL
    }));
  },
  configureDevelopmentEnv: function configureDevelopmentEnv(app, io) {
    if (app.config.PARSE_DASHBOARD) {
      app.use(app.config.PARSE_DASHBOARD, new ParseDashboard({
        'apps': [{
          'serverURL': 'http://' + app.config.host + ':' + app.config.port + '/parse',
          'appId': app.config.PARSE_APPLICATION_ID,
          'masterKey': app.config.PARSE_MASTER_KEY,
          'appName': app.config.MONGO_DB
        }]
      }, false));
    }
  }
});

module.exports = parseManager;