'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * This class is the essential class for determining
 * the identity of the logged in user.
 *
 * Never create a ViewerContext on your own, that is, DONT DO
 * > new ViewerContext(foo);  // THIS IS BAD!!
 *
 * Instead do
 * > ViewerContext.fetchWithFBUserID(fbUserID, callback);
 *
 * or
 * > ViewerContext.genFromViewerContextID(viewerContextID, callback);
 *
 * The reason is so we never create more than one viewer context per
 * request.
 * @module ViewerContext
 */
var ViewerContext = function (_Parse$Object) {
  _inherits(ViewerContext, _Parse$Object);

  function ViewerContext() {
    _classCallCheck(this, ViewerContext);

    // Pass the ClassName to the Parse.Object constructor
    return _possibleConstructorReturn(this, (ViewerContext.__proto__ || Object.getPrototypeOf(ViewerContext)).call(this, 'ViewerContext'));
    // Parse.Object.registerSubclass('ViewerContext', ViewerContext);
  }
  /**
   * @param {object} slug
   */


  _createClass(ViewerContext, [{
    key: 'getCredential',
    value: function getCredential(slug) {
      return this.get(slug);
    }

    /**
     * @param {object} slug
     * @param {object} token
     */

  }, {
    key: 'setCredential',
    value: function setCredential(slug, token) {
      return this.set(slug, token);
    }

    /**
     * @param {object} slug
     */

  }, {
    key: 'clearCredential',
    value: function clearCredential(slug) {
      return this.set(slug, {});
    }

    /**
     * @param {function} callback
     * @param {string} primaryAccountKey
     * @returns {object} viewerContext
     */

  }], [{
    key: 'genFromPrimaryAccount',
    value: function genFromPrimaryAccount(key, value, callback) {
      if (!callback) {
        return console.error('No callback passed into genFromClientID.');
      }
      if (!key) {
        return callback(null, new ViewerContext({}));
      }

      var query = new Parse.Query(ViewerContext);
      query.equalTo(key, value);
      query.first().then(function (viewerContext) {
        return callback(null, viewerContext);
      });
    }

    /** Generate From ViewerContext ID
     * @param {string} viewerContextID
     * @param {function} callback
     * @returns {object} viewerContext
     */

  }, {
    key: 'genFromViewerContextID',
    value: function genFromViewerContextID(viewerContextID, callback, accountKey) {
      if (!callback) {
        return console.error('No callback passed into genFromViewerContextID.');
      }

      if (!viewerContextID) {
        var vc = new ViewerContext();
        vc.save(null, {
          success: function success(data) {
            if (vc.getCredential(accountKey)) {
              return this.genFromPrimaryAccount(accountKey, vc.getCredential(accountKey), callback);
            } else {
              callback(null, vc);
            }
          },
          error: function error(data, _error) {
            callback(_error);
          }
        });
      } else {
        var query = new Parse.Query(ViewerContext);
        query.get(viewerContextID, {
          success: function success(viewerContext) {
            return callback(null, viewerContext);
          },
          error: function error(object, _error2) {
            return callback(_error2, new ViewerContext({}));
          }
        });
      }
    }

    /** TESTING: Generate Temp ViewerContext */

  }, {
    key: 'genTemporaryViewerContext_UNITTEST',
    value: function genTemporaryViewerContext_UNITTEST(initData) {
      var temp = new ViewerContext(initData);
      return temp;
    }
  }]);

  return ViewerContext;
}(Parse.Object);

exports.default = ViewerContext;